function varargout = YLEjournal()

%% Params
CANCER_CYCLES = 80;
k = 4;

dataName = './data/YLE_no_NaNs/YLEmatlab.mat';

%% Load data and preprocess.
load(dataName);
A = A + 3;  % Now min(min(A)) == 1.

%% What algorithms to run.
runCan = 0;
runCanKL = 0;
runCap = 0;
runSnmf = 0;
runAls = 0;
runAlsr = 0;
runSvd = 0;
runNmfKL = 0;
runCanJS = 0;
runNmfJS = 0;

fileName = './resultsJournal/real/YLE';
experName = 'YLE';

realWorldExecuteJournal(runCan, runCanKL, runCap, runSnmf, runAls, runAlsr, ...
    runSvd, runNmfKL, A, k, CANCER_CYCLES, fileName, experName, ...
    'runNmfJS', runNmfJS, 'runCanJS', runCanJS);

%% Compute errors
if nargout == 0
    realWorldPrint(fileName, A);
else
    [varargout{1}, varargout{2}] = realWorldPrint(fileName, A);
    varargout{3} = experName;
end

end