function eigenfaces(only_runtime, printing_option, NITER_LATITUDE_PRINT)

LAT_ITERS = 100;

%% Load and preprocess data.
A = YaleLeft();
A = double(A);
A = bsxfun(@rdivide, A, std(A));
A = bsxfun(@minus, A, min(A));

%% Params
CANCER_CYCLES = 80;
k = 40;

%% What algorithms to run.
runCan = 1;
runCanKL = 0;
runCap = 0;
runSnmf = 0;
runAls = 0;
runAlsr = 0;
runSvd = 0;
runNmfKL = 0;
runCanJS = 0;
runNmfJS = 0;
runLat = 1;
runNMF = 1;
runLatTrunk = 1;

fileName = './results/real/eigenfaces';
experName = 'eigenfaces';



%% Remove zero rows and columns.
idx = find(sum(A, 1) == 0);
if ~isempty(idx)
    A(:, idx) = [];
end
idx = find(sum(A, 2) == 0);
if ~isempty(idx)
    A(idx, :) = [];
end

realWorldExecute(runCan, runCanKL, runCap, runSnmf, runAls, runAlsr, ...
    runSvd, runNmfKL, A, k, CANCER_CYCLES, fileName, experName, runLat, runNMF, runLatTrunk, ...
    'runNmfJS', runNmfJS, 'runCanJS', runCanJS, 'LAT_ITERS', LAT_ITERS, 'only_runtime', only_runtime, ...
    'printing_option', printing_option, 'NITER_LATITUDE_PRINT', NITER_LATITUDE_PRINT);


end