function realWorldExecute(runCan, runCanKL, runCap, runSnmf, runAls, runAlsr, runSvd, runNmfKL, A, k, CANCER_CYCLES, fileName, experName, runLat, runNMF, runLatTrunk, varargin)

runCanJS = 0;
LAT_ITERS = 25;
only_runtime = 0;
printing_option = 0;
NITER_LATITUDE_PRINT = inf;

for i = 1 : numel(varargin)
    if isequal(varargin{i}, 'runCanJS')
        runCanJS = varargin{i+1};
    end
    if isequal(varargin{i}, 'runNmfJS')
        runNmfJS = varargin{i+1};
    end
    if isequal(varargin{i}, 'runCanIgnore')
        runCanIgnore = varargin{i+1};
    end
    if isequal(varargin{i}, 'LAT_ITERS')
        LAT_ITERS = varargin{i+1};
    end
    if isequal(varargin{i}, 'only_runtime')
        only_runtime = varargin{i+1};
    end
    if isequal(varargin{i}, 'printing_option')
        printing_option = varargin{i+1};
    end
    if isequal(varargin{i}, 'NITER_LATITUDE_PRINT')
        NITER_LATITUDE_PRINT = varargin{i+1};
    end
end


%% Run algorithms.
if runLat == 1
    [Blat, Clat, col, row, errors_lat, times_lat] = Latitude(A, k, 'NITER', LAT_ITERS, 'profiling', 1);
    if exist(strcat(fileName, '.mat'), 'file') > 0
        if only_runtime == 1
            save(fileName, 'times_lat', 'errors_lat', '-append');
        else
            save(fileName, 'Blat', 'Clat', 'col', 'row', 'times_lat', 'errors_lat', '-append');
        end
    else
        save(fileName, 'Blat', 'Clat', 'col', 'row', 'times_lat', 'errors_lat');
    end
end

if runLatTrunk == 1
    tic
    [Blat1, Clat1, col1, row1, errors_lat_trunc, times_lat_trunc] = Latitude(A, k-1, 'NITER', LAT_ITERS, 'profiling', 1);
    time_lat_trunc = toc;
    if exist(strcat(fileName, '.mat'), 'file') > 0
        if only_runtime == 1
            save(fileName, 'times_lat_trunc', 'errors_lat_trunc', '-append');
        else
            save(fileName, 'Blat1', 'Clat1', 'col1', 'row1', 'times_lat_trunc', 'errors_lat_trunc', '-append');
        end
    else
        save(fileName, 'Blat1', 'Clat1', 'col1', 'row1', 'times_lat_trunc', 'errors_lat_trunc');
    end
end

if runCan == 1
    tic
    [Bcan, Ccan, errorsCan] = Cancer(A, k, 'NCYCLES', CANCER_CYCLES);
    time_can = toc;
    if exist(strcat(fileName, '.mat'), 'file') > 0
        if only_runtime == 1
            save(fileName, 'time_can', '-append');
        else
            save(fileName, 'Bcan', 'Ccan', 'errorsCan', 'time_can', '-append');
        end
    else
        save(fileName, 'Bcan', 'Ccan', 'errorsCan', 'time_can');
    end
end

if runCanKL == 1
    tic
    [BcanKL, CcanKL, errorsCanKL] = Cancer(A, k, 'obj', 1, 'NCYCLES', CANCER_CYCLES);
    time_canKL = toc;
    if exist(strcat(fileName, '.mat'), 'file') > 0
        if only_runtime == 1
            save(fileName, 'time_canKL', '-append');
        else
            save(fileName, 'BcanKL', 'CcanKL', 'errorsCanKL', 'time_canKL', '-append');
        end
    else
        save(fileName, 'BcanKL', 'CcanKL', 'errorsCanKL', 'time_canKL');
    end
end

if runCap == 1
    tic
    [Bcap, Ccap] = Capricorn(A, k);
    time_cap = toc;
    if only_runtime == 1
        save(fileName, 'time_cap', '-append');
    else
        save(fileName, 'Bcap', 'Ccap', 'time_cap', '-append');
    end
end

if runSnmf == 1
    load(fileName);
    tic
    [sB, sC] = getHoyerSparsityOfFactors(Bcan, Ccan);
    [Bsnmf, Csnmf] = HoyerWrapper(A, k, sB, sC);
    time_snmf = toc;
    if only_runtime == 1
        save(fileName, 'time_snmf', '-append');
    else
        save(fileName, 'Bsnmf', 'Csnmf', 'time_snmf', '-append');
    end
end

if runAls == 1
    tic
    [Bals, Cals] = nmf_als(A, k);
    time_als = toc;
    if only_runtime == 1
        save(fileName, 'time_als', '-append');
    else
        save(fileName, 'Bals', 'Cals', 'time_als', '-append');
    end
end

if runAlsr == 1
    tic
    [Balsr, Calsr] = nmf_als_reg(A, k);
    time_alsr = toc;
    if only_runtime == 1
        save(fileName, 'time_alsr', '-append');
    else
        save(fileName, 'Balsr', 'Calsr', 'time_alsr', '-append');
    end
end

if runSvd == 1
    tic
    [Bsvd, Csvd] = svdWrapper(A, k);
    time_svd = toc;
    if only_runtime == 1
        save(fileName, 'time_svd', '-append');
    else
        save(fileName, 'Bsvd', 'Csvd', 'time_svd', '-append');
    end
end

if runNmfKL == 1
    tic
    [BnmfKL, CnmfKL] = NMF_KL(A, k);
    time_nmfKL = toc;
    if exist(strcat(fileName, '.mat'), 'file') > 0
        if only_runtime == 1
            save(fileName, 'time_nmfKL', '-append');
        else
            save(fileName, 'BnmfKL', 'CnmfKL', 'time_nmfKL', '-append');
        end
    else
        save(fileName, 'BnmfKL', 'CnmfKL', 'time_nmfKL');
    end
end

% if runNmfJS == 1
%     [BnmfJS, CnmfJS] = NMF_JS_wrapper(A, k);
%     if exist(strcat(fileName, '.mat'), 'file') > 0
%         save(fileName, 'BnmfJS', 'CnmfJS', '-append');
%     else
%         save(fileName, 'BnmfJS', 'CnmfJS');
%     end
% end

if runCanJS == 1
    tic
    [BcanJS, CcanJS, errorsCanJS] = Cancer(A, k, 'obj', 2, 'NCYCLES', CANCER_CYCLES);
    time_canJS = toc;
    if exist(strcat(fileName, '.mat'), 'file') > 0
        if only_runtime == 1
            save(fileName, 'time_canJS', '-append');
        else
            save(fileName, 'BcanJS', 'CcanJS', 'errorsCanJS', 'time_canJS', '-append');
        end
    else
        save(fileName, 'BcanJS', 'CcanJS', 'errorsCanJS', 'time_canJS');
    end
end

% if exist('runCanIgnore') && runCanIgnore == 1
%     W0 = A>0;
%     [BcanIgnore, CcanIgnore, errorsCanIgnore] = Cancer(A, k, 'obj', 2, 'NCYCLES', CANCER_CYCLES, 'W0', W0);
%     if exist(strcat(fileName, '.mat'), 'file') > 0
%         save(fileName, 'BcanIgnore', 'CcanIgnore', 'errorsCanIgnore', '-append');
%     else
%         save(fileName, 'BcanIgnore', 'CcanIgnore', 'errorsCanIgnore');
%     end
% end


if runNMF == 1
    tic
    [Bnmf, Cnmf] = nnmf_wrapper(A, k);
    nmf_time = toc;
    if only_runtime == 1
        save(fileName, 'nmf_time', '-append');
    else
        save(fileName, 'Bnmf', 'Cnmf', 'nmf_time', '-append');
    end
end


switch printing_option
    case 0
        %% Print errors.
        load(fileName);
        fprintf('\n');
        fprintf('--------%s-------------------------------\n', experName);
        
        if exist('errors_lat', 'var')
            %                 error_ = MixTropErrorRelative(A, Blat, Clat, col, row);
            error_ = getValByNiter(errors_lat, NITER_LATITUDE_PRINT);
            fprintf('Latitude error: %f\n', error_);
        end
        
        if exist('errors_lat_trunc', 'var')
            %                 error_ = MixTropErrorRelative(A, Blat1, Clat1, col1, row1);
            error_ = getValByNiter(errors_lat_trunc, NITER_LATITUDE_PRINT);
            fprintf('Truncated Latitude error: %f\n', error_);
        end
        
        if exist('Bsvd', 'var')
            error_ = norm(A - Bsvd*Csvd, 'fro') / norm(A, 'fro');
            fprintf('SVD error: %f\n', error_);
        end
        
        if exist('Bnmf', 'var')
            error_ = norm(A - Bnmf*Cnmf, 'fro') / norm(A, 'fro');
            fprintf('NNMF error: %f\n', error_);
        end
        
        if exist('Bcan', 'var')
            error_ = norm(A - MaxProduct(Bcan, Ccan), 'fro') / norm(A, 'fro');
            fprintf('Cancer error: %f\n', error_);
        end
        
        % if exist('Bcap', 'var')
        %     error_ = norm(A - MaxProduct(Bcap, Ccap), 'fro') / norm(A, 'fro');
        %     fprintf('Capricorn error: %f\n', error_);
        % end
        
        % if exist('Bsnmf', 'var')
        %     error_ = norm(A - Bsnmf*Csnmf, 'fro') / norm(A, 'fro');
        %     fprintf('Hoyer error: %f\n', error_);
        % end
        
        % if exist('Bals', 'var')
        %     error_ = norm(A - Bals*Cals, 'fro') / norm(A, 'fro');
        %     fprintf('ALS error: %f\n', error_);
        % end
        
        % if exist('Balsr', 'var')
        %     error_ = norm(A - Balsr*Calsr, 'fro') / norm(A, 'fro');
        %     fprintf('ALS reg error: %f\n', error_);
        % end
        
        fprintf('\n');
        fprintf('\n');
        
    case 1
        
        %% Print time.
        load(fileName);
        fprintf('RUNTIME\n');
        fprintf('--------%s-------------------------------\n', experName);
        
        if exist('times_lat', 'var')
            runtime = getValByNiter(times_lat, NITER_LATITUDE_PRINT);
            fprintf('Latitude time: %f\n', runtime);
        end
        
        if exist('times_lat_trunc', 'var')
            runtime = getValByNiter(times_lat_trunc, NITER_LATITUDE_PRINT);
            fprintf('Truncated Latitude time: %f\n', runtime);
        end
        
        if exist('time_svd', 'var')
            fprintf('SVD time: %f\n', time_svd);
        end
        
        if exist('nmf_time', 'var')
            fprintf('NNMF time: %f\n', nmf_time);
        end
        
        if exist('time_can', 'var')
            fprintf('Cancer time: %f\n', time_can);
        end
        
        % if exist('Bcap', 'var')
        %     error_ = norm(A - MaxProduct(Bcap, Ccap), 'fro') / norm(A, 'fro');
        %     fprintf('Capricorn error: %f\n', error_);
        % end
        
        % if exist('Bsnmf', 'var')
        %     error_ = norm(A - Bsnmf*Csnmf, 'fro') / norm(A, 'fro');
        %     fprintf('Hoyer error: %f\n', error_);
        % end
        
        % if exist('Bals', 'var')
        %     error_ = norm(A - Bals*Cals, 'fro') / norm(A, 'fro');
        %     fprintf('ALS error: %f\n', error_);
        % end
        
        % if exist('Balsr', 'var')
        %     error_ = norm(A - Balsr*Calsr, 'fro') / norm(A, 'fro');
        %     fprintf('ALS reg error: %f\n', error_);
        % end
        
        fprintf('\n');
        fprintf('\n');
        
    otherwise
        error('Wrong printing option');
end

% %% Data specs.
% [n, m] = size(A);
% density = nnz(A) / numel(A);
% fprintf('Data specs  %s\n', experName);
% fprintf('rows: %d\n', n);
% fprintf('columns: %d\n', m);
% fprintf('density: %f\n', density);
% fprintf('\n');
% fprintf('\n');


end


function val = getValByNiter(values, NITER_LATITUDE_PRINT)
idx = min(NITER_LATITUDE_PRINT, numel(values));
val = values(idx);
end