function CdensityMix(varargin)
gen = 0;
action_ = 'plot';
if nargin > 0
    action_ = varargin{1};
end

% lockName = 'densityLock';
% if exist(lockName) > 0
%   return;
% end

rng('shuffle');
% setpath
% parpool

dataName = './data/synth/densityMix';

canName = './results/synth/densityMixCan.mat';
capName = './results/synth/densityMixCap.mat';
snmfName = './results/synth/densityMixSNMF.mat';
alsName = './results/synth/densityMixALS.mat';
alsrName = './results/synth/densityMixALSR.mat';
svdName = './results/synth/densityMixSVD.mat';
alsr5Name = './results/synth/densityMixALSR5.mat';
latName = './results/synth/densityMixLat.mat';
nmfName = './results/synth/densityMixNMF.mat';

saveName = './figs/densityMix.pdf';
sparseName = './figs/densityMixSparsity.pdf';

xlabelStr = 'Factor density';
ylabelStr = 'Frobenius error';

addLegend = 0;

n = 1000;
m = 800;
k = 10;
noise = 0.01;
minDens = 0.1;
densInc = 0.1;
iters = 10;
nInstances = 10;

if strcmp(action_, 'run')
    if gen == 1
        CgenerateDensityMixData(n, m, k, noise, minDens, densInc, iters, nInstances, dataName);
    else
        %          CrunLat(k, iters, nInstances, dataName, latName);
        %         combineAndDelete(latName, iters, nInstances, 'lat');
%         CrunSVD(k, iters, nInstances, dataName, svdName);
%         combineAndDelete(svdName, iters, nInstances, 'svd');
%         CrunNMF(k, iters, nInstances, dataName, nmfName);
%         combineAndDelete(nmfName, iters, nInstances, 'nmf');
        CrunCan(k, iters, nInstances, dataName, canName);
        combineAndDelete(canName, iters, nInstances, 'can');
        
        
        % CrunCap(k, iters, nInstances, dataName, capName);
        % combineAndDelete(capName, iters, nInstances, 'cap');
        %         CrunSnmf(k, iters, nInstances, dataName, snmfName, latName);
        %         combineAndDelete(snmfName, iters, nInstances, 'snmf');
        %         CrunAls(k, iters, nInstances, dataName, alsName);
        %         combineAndDelete(alsName, iters, nInstances, 'als');
        %         CrunAlsr(k, iters, nInstances, dataName, alsrName);
        %         combineAndDelete(alsrName, iters, nInstances, 'alsr');
        %         CrunAlsr5(k, iters, nInstances, dataName, alsr5Name);
        %         combineAndDelete(alsr5Name, iters, nInstances, 'alsr5');
    end
    % fid = fopen(lockName, 'wt' );
    % fprintf( fid, 'Do not rerun\n');
    % fclose(fid);
else
    Cplot(minDens, densInc, iters, nInstances, dataName, ...
        canName, capName, snmfName, alsName, alsrName, svdName, alsr5Name, latName, nmfName, ...
        saveName, sparseName, addLegend, xlabelStr, ylabelStr);
end
end