function CgenerateDensityMixData(n, m, k, noise, minDens, densInc, densIters, nInstances, dataName)
% Find densities range.
densities = nan(densIters, 1);
for i = 1 : densIters
    densities(i) = minDens + (i-1)*densInc;
end

% Generate data.
for i = 1 : densIters
    for j = 1 : nInstances
        B = rand(n, k);
        C = rand(k, m);
        Bmask = rand(size(B)) < densities(i);
        Cmask = rand(size(C)) < densities(i);
        Borig{i}{j} = B .* Bmask;
        Corig{i}{j} = C .* Cmask;
	RANGE = 5;
col{i}{j} = -RANGE + 2*RANGE*rand(n, 1);
row{i}{j} = -RANGE + 2*RANGE*rand(1, m);
Aorig{i}{j} = MixProd(Borig{i}{j}, Corig{i}{j}, col{i}{j}, row{i}{j});
        % Add noise.       
        N = noise * randn(size(Aorig{i}{j}));
        Anoisy{i}{j} = max(0, Aorig{i}{j} + N);
    end
end

save(dataName, 'Aorig', 'Anoisy', 'Borig', 'Corig', 'col', 'row');

end

