function CgenerateSkewedData(n, m, k, density, minNoise, noiseInc, noiseIters, min_param, max_param, nInstances, dataName)
% Find densities range.
noiseLevels = nan(noiseIters, 1);
for i = 1 : noiseIters
    noiseLevels(i) = minNoise + (i-1)*noiseInc;
end

% Generate data.
for i = 1 : noiseIters
    for j = 1 : nInstances
        B = rand(n, k);
        C = rand(k, m);
        Bmask = rand(size(B)) < density;
        Cmask = rand(size(C)) < density;	
        Borig{i}{j} = B .* Bmask;
        Corig{i}{j} = C .* Cmask;



	RANGE = max_param - min_param;
col{i}{j} = min_param + RANGE*rand(n, 1);
row{i}{j} = min_param + RANGE*rand(1, m);

% Generate the input matrix.
Aorig{i}{j} = MixProd(Borig{i}{j}, Corig{i}{j}, col{i}{j}, row{i}{j});
        % Add noise.
        N = noiseLevels(i) * randn(size(Aorig{i}{j}));
        Anoisy{i}{j} = max(0, Aorig{i}{j} + N);
    end
end

save(dataName, 'Aorig', 'Anoisy', 'Borig', 'Corig', 'col', 'row');

end
