function CnoiseNMF(varargin)
action_ = 'plot';
if nargin > 0
    action_ = varargin{1};
end

% lockName = 'noiseLock';
% if exist(lockName) > 0
%   return;
% end

% rng('shuffle');
% setpath
% parpool

dataName = './data/synth/noise2';

canName = './results/synth/noise2Can.mat';
capName = './results/synth/noise2Cap.mat';
snmfName = './results/synth/noise2SNMF.mat';
alsName = './results/synth/noise2ALS.mat';
alsrName = './results/synth/noise2ALSR.mat';
svdName = './results/synth/noise2SVD.mat';
alsr5Name = './results/synth/noise2ALSR5.mat';
latName = './results/synth/noise2Lat.mat';
nmfName = './results/synth/noise2NMF.mat';

saveName = './figs/noise2.pdf';
sparseName = './figs/noiseSparsity2.pdf';

xlabelStr = 'Noise';
ylabelStr = 'Frobenius error';

addLegend = 0;
n = 1000;
m = 800;
k = 10;
density = 0.2;
minNoise = 0;
noiseInc = 0.01;
iters = 15;
nInstances = 10;

gen = 0;

if strcmp(action_, 'run')
    if gen == 1
        CgenerateNoise2Data(n, m, k, density, minNoise, noiseInc, iters, nInstances, dataName);
    else
%         CrunLat(k, iters, nInstances, dataName, latName);
%         combineAndDelete(latName, iters, nInstances, 'lat');
%         CrunSVD(k, iters, nInstances, dataName, svdName);
%         combineAndDelete(svdName, iters, nInstances, 'svd');
%         CrunNMF(k, iters, nInstances, dataName, nmfName);
%         combineAndDelete(nmfName, iters, nInstances, 'nmf');
        CrunCan(k, iters, nInstances, dataName, canName);
        combineAndDelete(canName, iters, nInstances, 'can');
        
        
        % CrunCap(k, iters, nInstances, dataName, capName);
        % combineAndDelete(capName, iters, nInstances, 'cap');
        %         CrunSnmf(k, iters, nInstances, dataName, snmfName, latName);
        %         combineAndDelete(snmfName, iters, nInstances, 'snmf');
        %         CrunAls(k, iters, nInstances, dataName, alsName);
        %         combineAndDelete(alsName, iters, nInstances, 'als');
        %         CrunAlsr(k, iters, nInstances, dataName, alsrName);
        %         combineAndDelete(alsrName, iters, nInstances, 'alsr');
        %         CrunAlsr5(k, iters, nInstances, dataName, alsr5Name);
        %         combineAndDelete(alsr5Name, iters, nInstances, 'alsr5');
    end
    
    % fid = fopen(lockName, 'wt' );
    % fprintf( fid, 'Do not rerun\n');
    % fclose(fid);
    
else
    Cplot(minNoise, noiseInc, iters, nInstances, dataName, ...
        canName, capName, snmfName, alsName, alsrName, svdName, alsr5Name, latName, nmfName, ...
        saveName, sparseName, addLegend, xlabelStr, ylabelStr);
    
end

end