function dimMerged(varargin)
gen = 0;
action_ = 'plot';
plot_option = 0; % Standard mixed error.
% plot_option = 1; % Split the error on alpha threshold.
th1 = 0;   % Used for splitting the error for alpha intervals 
           %[MIN, th1], [th1, th2], [th2, MAX];
th2 = 5;   
if nargin > 0
    for i = 1 : numel(varargin)
        if isequal(varargin{i}, 'plot') || isequal(varargin{i}, 'run')
            action_ = varargin{i};
        end
        if isequal(varargin{i}, 'plot_option')
            plot_option = varargin{i+1};
        end
        if isequal(varargin{i}, 'th1')
            th1 = varargin{i+1};
        end
        if isequal(varargin{i}, 'th2')
            th2 = varargin{i+1};
        end
    end
end

% lockName = 'dimLock';
% if exist(lockName) > 0
%   return;
% end

rng('shuffle');
% setpath
% parpool

dataName = './data/synth/dimMerged';

canName = './results/synth/dimMergedCan.mat';
capName = './results/synth/dimMergedCap.mat';
snmfName = './results/synth/dimMergedSNMF.mat';
alsName = './results/synth/dimMergedALS.mat';
alsrName = './results/synth/dimMergedALSR.mat';
svdName = './results/synth/dimMergedSVD.mat';
alsr5Name = './results/synth/dimMergedALSR5.mat';
latName = './results/synth/dimMergedLat.mat';
nmfName = './results/synth/dimMergedNMF.mat';

saveName = './figs/dimMerged.pdf';
sparseName = './figs/dimMergedSparsity.pdf';

xlabelStr = 'k';
ylabelStr = 'Frobenius error';

addLegend = 0;

n = 1000;
m = 800;
noise = 0.01;
density = 0.5;
minK = 2;
incK = 2;
iters = 20;
nInstances = 10;

if strcmp(action_, 'run')
    if gen == 1
        CgenerateDimMixData(n, m, noise, density, minK, incK, iters, nInstances, dataName);
    else
        %         CrunDimLat(minK, incK, iters, nInstances, dataName, latName);
        %         combineAndDelete(latName, iters, nInstances, 'lat');
        %         CrunDimSVD(minK, incK, iters, nInstances, dataName, svdName);
        %         combineAndDelete(svdName, iters, nInstances, 'svd');
        %         CrunDimNMF(minK, incK, iters, nInstances, dataName, nmfName);
        %         combineAndDelete(nmfName, iters, nInstances, 'nmf');
        %         CrunDimCan(minK, incK, iters, nInstances, dataName, canName);
        %         combineAndDelete(canName, iters, nInstances, 'can');
        
        
        
        % % CrunDimCap(minK, incK, iters, nInstances, dataName, capName);
        % % combineAndDelete(capName, iters, nInstances, 'cap');
        %  CrunDimSnmf(minK, incK, iters, nInstances, dataName, snmfName, latName);
        %  combineAndDelete(snmfName, iters, nInstances, 'snmf');
        %  CrunDimAls(minK, incK, iters, nInstances, dataName, alsName);
        %  combineAndDelete(alsName, iters, nInstances, 'als');
        %  CrunDimAlsr(minK, incK, iters, nInstances, dataName, alsrName);
        %  combineAndDelete(alsrName, iters, nInstances, 'alsr');
        
        %  CrunDimAlsr5(minK, incK, iters, nInstances, dataName, alsr5Name);
        %  combineAndDelete(alsr5Name, iters, nInstances, 'alsr5');
    end
    % fid = fopen(lockName, 'wt' );
    % fprintf( fid, 'Do not rerun\n');
    % fclose(fid);
else
    Cplot(minK, incK, iters, nInstances, dataName, ...
        canName, capName, snmfName, alsName, alsrName, svdName, alsr5Name, latName, nmfName, ...
        saveName, sparseName, addLegend, xlabelStr, ylabelStr, 'plot_option', plot_option, ...
        'th1', th1, 'th2', th2);
end

end
