function lat_truncated_noise(varargin)
gen = 0;
action_ = 'plot';
if nargin > 0
    action_ = varargin{1};
end

rng('shuffle');

dataName = './data/synth/truncated';
noiseDataName = './data/synth/noise3';

canName = './results/truncatedCan.mat';
capName = './results/truncatedCap.mat';
snmfName = './results/truncatedSNMF.mat';
alsName = './results/truncatedALS.mat';
alsrName = './results/truncatedALSR.mat';
svdName = './results/truncatedSVD.mat';
alsr5Name = './results/truncatedALSR5.mat';
latName = './results/truncatedLat.mat';
nmfName = './results/truncatedNMF.mat';

noisecanName = './results/noise3Can.mat';
noisecapName = './results/noise3Cap.mat';
noisesnmfName = './results/noise3SNMF.mat';
noisealsName = './results/noise3ALS.mat';
noisealsrName = './results/nois3eALSR.mat';
noisesvdName = './results/noise3SVD.mat';
noisealsr5Name = './results/noise3ALSR5.mat';
noiselatName = './results/noise3Lat.mat';
noisenmfName = './results/noise3NMF.mat';

% load(noisecanName);
% save(canName, 'Bcan', 'Ccan');
% load(noisesvdName);
% save(canName, 'Bsvd', 'Csvd');

saveName = './figs/truncated.pdf';
sparseName = './figs/truncatedSparsity.pdf';
xlabelStr = 'k';
ylabelStr = 'Frobenius error';
addLegend = 0;

minK = 1;
incK = 1;
iters = 10;
nInstances = 10;
fixed_iter = 2;

if strcmp(action_, 'run')
    if gen == 1
        % Generate data.
%         load(noiseDataName);
%         for i = 1 : iters
%             for j = 1 : nInstances
%                 Aorig_{i}{j} = Aorig{fixed_iter}{j};
%                 Anoisy_{i}{j} = Anoisy{fixed_iter}{j};
%             end
%         end
%         Aorig = Aorig_;
%         Anoisy = Anoisy_;
%         save(dataName, 'Aorig', 'Anoisy', 'Borig', 'Corig', 'col', 'row');
%         makeFakeSet(noisecanName, canName, svdName, nmfName, fixed_iter, iters, 'cancer');
%         makeFakeSet(noisesvdName, canName, svdName, nmfName, fixed_iter, iters, 'svd');
        makeFakeSet(noisenmfName, canName, svdName, nmfName, fixed_iter, iters, 'nmf');
    else
%         CrunDimLat(minK, incK, iters, nInstances, dataName, latName);
        combineAndDelete(latName, iters, nInstances, 'lat');
        %         CrunDimSVD(minK, incK, iters, nInstances, dataName, svdName);
        %         combineAndDelete(svdName, iters, nInstances, 'svd');
        %         CrunDimNMF(minK, incK, iters, nInstances, dataName, nmfName);
        %         combineAndDelete(nmfName, iters, nInstances, 'nmf');
%         CrunDimCan(minK, incK, iters, nInstances, dataName, canName);
%         combineAndDelete(canName, iters, nInstances, 'can');
        
        
        
        % % CrunDimCap(minK, incK, iters, nInstances, dataName, capName);
        % % combineAndDelete(capName, iters, nInstances, 'cap');
        %  CrunDimSnmf(minK, incK, iters, nInstances, dataName, snmfName, latName);
        %  combineAndDelete(snmfName, iters, nInstances, 'snmf');
        %  CrunDimAls(minK, incK, iters, nInstances, dataName, alsName);
        %  combineAndDelete(alsName, iters, nInstances, 'als');
        %  CrunDimAlsr(minK, incK, iters, nInstances, dataName, alsrName);
        %  combineAndDelete(alsrName, iters, nInstances, 'alsr');
        
        %  CrunDimAlsr5(minK, incK, iters, nInstances, dataName, alsr5Name);
        %  combineAndDelete(alsr5Name, iters, nInstances, 'alsr5');
    end
    % fid = fopen(lockName, 'wt' );
    % fprintf( fid, 'Do not rerun\n');
    % fclose(fid);
else
    Cplot(minK, incK, iters, nInstances, dataName, ...
        canName, capName, snmfName, alsName, alsrName, svdName, alsr5Name, latName, nmfName, ...
        saveName, sparseName, addLegend, xlabelStr, ylabelStr);
end

end


function makeFakeSet(oldFileName, canName, svdName, nmfName, fixed_iter, iters, alg)
if exist(oldFileName)
    load(oldFileName);
    switch alg
        case 'cancer'
            Bcan = composeFakeSet(Bcan, fixed_iter, iters);
            Ccan = composeFakeSet(Ccan, fixed_iter, iters);
            save(canName, 'Bcan', 'Ccan');
        case 'svd'
            Bsvd = composeFakeSet(Bsvd, fixed_iter, iters);
            Csvd = composeFakeSet(Csvd, fixed_iter, iters);
            save(svdName, 'Bsvd', 'Csvd');
        case 'nmf'
            Bnmf = composeFakeSet(Bnmf, fixed_iter, iters);
            Cnmf = composeFakeSet(Cnmf, fixed_iter, iters);
            save(nmfName, 'Bnmf', 'Cnmf');
    end
end
end

function A_ = composeFakeSet(A, fixed_iter, iters)
for iter = 1 : iters
    A_{iter} = A{fixed_iter};
end
end

% names = getTempNames(fileName, max_dim);
%
% %% Run algorithms for each param value.
% load(dataName);
% Aorig = Aorig{iter};
% Anoisy = Anoisy{iter};
% if run_ == 1
%     parfor k = 1 : 10
%         runInstances(names{i}, Anoisy, nInstances, k);
%     end
%     combineAndDelete(fileName, nInstances, max_dim);
% end
%
% % Cplot(xMin, xInc, xIters, nInstances, dataName, ...
% %     canName, capName, snmfName, alsName, alsrName, svdName, alsr5Name, latName, nmfName, ...
% %     saveName, sparseName, addLegend, xlabelStr, ylabelStr)
%
% end
%
%
% function runInstances(name, Anoisy, nInstances, k)
%
% %% Load a partially completed temp file, or create a new one with dummy values.
% if exist(name, 'file') > 0
%     load(name);
% else
%     for j = 1 : nInstances
%         B{j} = nan;  % Dummy values.
%         C{j} = nan;
%         col{j} = nan;
%         row{j} = nan;
%     end
%     save(name, 'B', 'C', 'col', 'row');
% end
%
% %% Run algorithms.
% for j = 1 : nInstances
%     if isDummy(B{j}) || isDummy(C{j})
%         [B{j}, C{j}, col{j}, row{j}] = Latitude(Anoisy{j}, k);
%         if exist(name, 'file') > 0
%             save(name, 'B', 'C', 'row', 'col', '-append');
%         else
%             save(name, 'B', 'C', 'row', 'col');
%         end
%     end
%
% end
% end
%
%
% function combineAndDelete(fileName, nInstances, nIters)
% names = getTempNames(fileName, nIters);
%
% %% Combine results
% for i = 1 : nIters
%     try
%         load(names{i});
%     catch e
%         return;
%     end
%     if ~verify(B, C, nInstances)
%         display('Synth experiments are not complete!\n');
%         return;
%     end
%
%     Blat{i} = B;
%     Clat{i} = C;
%     colLat{i} = col;
%     rowLat{i} = row;
% end
%
% save(fileName, 'Blat', 'Clat', 'colLat', 'rowLat');
%
%
% %% Delete temporary files.
% for i = 1 : nIters
%     delete(names{i});
% end
%
% end
%
% function a = verify(B, C, nInstances)
% a = 1;
% for j = 1 : nInstances
%     if isDummy(B{j}) || isDummy(C{j})
%         a = 0;
%     end
% end
% end