function thetaRow = getParamsGradDescent(thetaCol, A, F, G)
b = thetaCol;
P = F - G;
Q = A - G;

mn = -5;
mx = 5;
NITER = 10;
grad = getGrad(b, mn, P, Q);
if grad >= 0
    thetaRow = mn;
    return;
end
grad = getGrad(b, mx, P, Q);
if grad < 0
    thetaRow = mx;
    return;
end
mid = (mn + mx)/2;
for iter = 1 : NITER
    grad = getGrad(b, mid, P, Q);
    if grad < 0
        mn = mid;
    else
        mx = mid;
    end
    mid = (mn + mx)/2;
end
thetaRow = mid;
end